$BetterTrust::Version = "3"; // Don't change unless you know what your doing. Set to -1 to disable.
if(!isFile("config/client/BT/BT.cs")) {echo("Better Trust was loaded for the first time!");$BetterTrust::FirstLoad=true;$BetterTrust::UseNewGui=true;$BetterTrust::Version = $BetterTrust::Version;$BetterTrust::IgnoreAutoMessages="1";}
exec("./BT_FirstLoad.gui");
exec("./BT_Options.gui");
$BetterTrust::Controls::Added = false;

// Version Control //

if($BetterTrust::Version !$= $BetterTrust::Version && $BetterTrust::Version !$= "-1" && $BetterTrust::FirstLoad != true) {
	// Update required prefs...	
	$BetterTrust::AutoAccept = $BetterTrust::AutoAccept;
	$BetterTrust::AutoReject = $BetterTrust::AutoReject;
	$BetterTrust::AutoIgnore = $BetterTrust::AutoIgnore;
	$BetterTrust::IgnoreAutoMessages = $BetterTrust::IgnoreAutoMessages;
	$BetterTrust::UseNewGui = $BetterTrust::UseNewGui;
	$BetterTrust::FirstLoad = true; // Only because if there are any changes to welcome.
	$BetterTrust::Version = $BetterTrust::Version;
	export("$BetterTrust::*","config/client/BT/BT.cs");
}

////////////////////

package BetterTrust {
	
	function TI_Window::onWake(%this, %var)
	{	
		if(isObject($BT_Timer))
		   cancel($BT_Timer);
		
		TI_FullMessageA.setValue(strReplace(TI_FullMessageA.getValue(), "FULL TRUST", "<color:FF0000>FULL TRUST<color:000000>"));
		TI_FullMessageA.setValue(strReplace(TI_FullMessageA.getValue(), "BUILD TRUST", "<color:FF6600>BUILD TRUST<color:000000>"));
		if($BetterTrust::UseNewGui $= "1") {
			TI_APPROVED.setValue("<color:C80000>Server not supported.<color:000000>");
			TI_ADMIN.setValue(BT_isPlayerAdmin());
			commandtoserver('BT_isAT', TI_NAME.getValue());
		}
		$BT_Time = 118;
		BT_RejectionTimer();
		schedule(0, 0, BT_AutoCheck);
	}
	
	function mm_Fade::onWake(%this)
	{
		if($BetterTrust::FirstLoad == true) {
			canvas.pushDialog(BT_FirstLoad);
			$BetterTrust::FirstLoad = false;	
		}
	}
	
	function TI_Window::onSleep(%this)
	{
		cancel($BT_Timer);
	}
	
	function onExit() 
	{
		echo("Exporting Better Trust prefs");
		export("$BetterTrust::*","config/client/BT/BT.cs");
		parent::onExit();
	}
	
};

		if($BetterTrust::Controls::Added != true) {
			if($BetterTrust::UseNewGui $= "1") {
				TrustInviteGui.delete();
				exec("Add-ons/Script_BetterTrust/TrustInviteGui.gui");
			}
			$remapDivision[$remapCount] = "Better Trust";
			$remapName[$remapCount] = "Open Options Dialog";
			$remapCmd[$remapCount] = "BT_OpenOptions";
			$remapCount++;
			$BetterTrust::Controls::Added = true;
 }
 
 activatePackage(BetterTrust);
 
 function BT_OpenOptions()
 {
	canvas.pushDialog(BT_OPTIONS);	 
 }
 
  ////////////////////////////////////////
  
  function clientCmdBT_isAT(%var)
  {
	if(%var == 0) {
	TI_APPROVED.setValue("<color:FF0000>NO<color:000000>");
	return;
	}
	
	if(%var == 1) {
	TI_APPROVED.setValue("<color:00FF00>YES<color:000000>");  
	return;
	}
  }
 
 function BT_LoadPref()
 {
	if(isFile("config/client/BT/BT.cs")) {
		exec("config/client/BT/BT.cs");	
	} else {
		$BetterTrust::AutoAccept = "0";
		$BetterTrust::AutoReject = "0";
		$BetterTrust::AutoIgnore = "0";
		$BetterTrust::IgnoreAutoMessages = "1";
		$BetterTrust::UseNewGui = "1";
		export("$BetterTrust::*","config/client/BT/BT.cs");
	} 
 }
 
 ////////////////////////////////////////
 
function BT_isPlayerAdmin()
{
	for(%i=-1; %i < NPL_List.RowCount(); %i++)
	{
		%list = NPL_List.getrowtext(%i);
		%name = getField(%list, 1);
		if(%name $= TI_Name.getValue()) {
			%admin = getField(%list, 0);
			
			if(%admin $= "S" || %admin $= "A") {
				return "<color:00FF00>YES<color:000000>";	
			} else {
				return "<color:FF0000>NO<color:000000>";	
			}
		}
	}	 
}

function BT_RejectionTimer()
{
	$BT_Timer = schedule(1000, 0, BT_RejectionTimer);
	$BT_Time--;
	TI_Window.setText(TI_Window.text SPC "- Expires in" SPC $BT_Time SPC "seconds.");
	if($BT_Time <= 0) {
		cancel($BT_Timer);
		TrustInviteGui.clickReject();
		return;	
	}
}

function BT_AlertOnOldGUIChoose()
{
	if(OptUseOldGui.getValue() == 0) {
	messageBoxOK("Doh!", "You have selected to use the old trust gui!\nDoing so will disable some features. If you decide you want the new, and better GUI back just disable this option.\n\nYou must restart Blockland after disabling the new GUI.");	
	}
}
 ////////////////////////////////////////
 
 function AutoIgnore()
 {
	$BetterTrust::AutoReject = false;
	$BetterTrust::AutoAccept = false;
	OptAutoReject.setValue(0);
	OptAutoAccept.setValue(0);
 }
 
 function AutoReject()
 {
	$BetterTrust::AutoIgnore = false;
	$BetterTrust::AutoAccept = false;	 
	OptAutoIgnore.setValue(0);
	OptAutoAccept.setValue(0);
 }
 
 function AutoAccept()
 {
	$BetterTrust::AutoReject = false;
	$BetterTrust::AutoIgnore = false;
	OptAutoReject.setValue(0);
	OptAutoIgnore.setValue(0);	 
 }
 
 function BT_AutoCheck()
 {
	 if($BetterTrust::IgnoreAutoMessages $= "0") {
		if($BetterTrust::AutoAccept $= "1") {
		newChatHud_AddLine("<color:ffffff>Auto-Accepted trust invite from" SPC TI_Name.getValue() @ ".");
		TrustInviteGui.clickAccept();
		}
		
		if($BetterTrust::AutoReject $= "1") {
			newChatHud_AddLine("<color:ffffff>Auto-Rejected trust invite from" SPC TI_Name.getValue() @ ".");
			TrustInviteGui.clickReject();
		}
		
		if($BetterTrust::AutoIgnore $= "1") {
			newChatHud_AddLine("<color:ffffff>Auto-Ignored trust invite from" SPC TI_Name.getValue() @ ".");
			TrustInviteGui.clickIgnore();
			MessageCallback(MessageBoxYesNoDlg,MessageBoxYesNoDlg.yesCallback);
		}
	} else {
		if($BetterTrust::AutoAccept $= "1") {
		TrustInviteGui.clickAccept();
		}
		
		if($BetterTrust::AutoReject $= "1") {
			TrustInviteGui.clickReject();
		}
		
		if($BetterTrust::AutoIgnore $= "1") {
			TrustInviteGui.clickIgnore();
			MessageCallback(MessageBoxYesNoDlg,MessageBoxYesNoDlg.yesCallback);
		}		
	} 
 }
 
 function BT_LoadWelcome()
 {
	%file = new FIleobject();
	%file.openForRead("Add-ons/Script_BetterTrust/welcome.txt");
	
	while(!%file.isEOF()) {
		%line = %file.readLine();
		
		%text = %text @ %line;	
		%text = strReplace(%text, "<nl>", "\n");
	}
	
	BT_Welcome_Text.setValue(%text);	 
 }
 
 ////////////////////////////////////////
 
 BT_LoadWelcome();
 
 
 